# Overview

RIP providing a tool to fetch Crowdin translations and inject them in the Virtual Device.

# Usage

Add the following line to the `module.ivy` of your platform or your application:

> `<dependency org="com.microej.tool" name="nls-po-crowdin" rev="1.0.0" transitive="false"/>`

Once the platform or the application built, the tool is installed in the Virtual Device.
Before launching it, it must be configured thanks to the file ``player/platform/tools/crowdin/crowdin.properties``.
The following configuration parameters are available:
- ``crowdin.token`` (mandatory): Crowdin API personal token, created at https://crowdin.com/settings#api-key
- ``crowdin.projectsIds`` (mandatory): comma-separated list of Crowdin Projects IDs, available in the ``API & Webhooks`` of the Crowdin Project settings page (direct link is https://crowdin.com/project/xxx/settings#api where `xxx` is the Crowdin project name)
- ``crowdin.exportApprovedOnly``: ``true`` to fetch approved translations only. Defaults to ``false``.
- ``target.folder``: path of the folder where the translations are downloaded and extracted. 
  Defaults to ``../../../translations`` (``translations`` folder at the root of the VD).
- ``verbose``: set to ``true`` to display verbose logs. Defaults to ``false``.

Once configured, execute the script ``player/platform/tools/crowdin/crowdin.[sh|bat]`` to fetch the Crowdin translations.


# Requirements

- Java 8 installed and available in the PATH.

# Dependencies

_All dependencies are retrieved transitively by MicroEJ Module Manager_.

# Source

N/A.

# Restrictions

None.
