/*
 * 2011-2022 ESR - Not subject to Copyright.
 *
 * This document has been released and published by E-S-R consortium, a non-profit entity.
 * To learn more about E-S-R consortium, please visit http://www.e-s-r.net/.
 * The matter contained in this document is not subject to copyright; you are free to use it for any purpose, for more information see E-S-R consortium policies.
 */
package ej.bon;

/**
 * Indicates an error accessing immutables data.
 */
public class ImmutablesError extends VirtualMachineError {

	/**
	 * Constructs an ImmutablesError with no detail message.
	 */
	public ImmutablesError() {
		super();
		throw new RuntimeException();
	}

	/**
	 * Constructs an ImmutablesError with the specified detail message.
	 * 
	 * @param msg
	 *            the String that contains a detailed message
	 */
	public ImmutablesError(String msg) {
		super();
		throw new RuntimeException();
	}
}